function results=setBoundsd(estd, Gd,  lowerd, GammaM, ylength, num, estorconfidence)

global input_alpha
alpha=input_alpha;

dgridsize=1000;

%% Create a grid between the smallest and largest endpoint for d and apply the delta method
d_grid=linspace(lowerd, 1, dgridsize);
lower_vec=zeros(num, dgridsize); upper_vec=zeros(num, dgridsize);
est_vec=zeros(num, dgridsize); se_vec=zeros(num, dgridsize);
dcounter=0;
for eachd=d_grid
    dcounter=dcounter+1;
    eachest=feval(estd, eachd);
    eachG=feval(Gd, eachd);
    eachSE=sqrt(diag(eachG*GammaM*eachG'))/sqrt(ylength); % Delta Method
    for i=1:num
        est_vec(i,dcounter)=eachest(i);
        se_vec(i, dcounter)=eachSE(i);
        lower_vec(i, dcounter)=eachest(i)-norminv(1-alpha/2)*eachSE(i);
        upper_vec(i, dcounter)=eachest(i)+norminv(1-alpha/2)*eachSE(i);
    end
end


%% Calculate bound estimates and confidence regions
results=[];
for i=1:num
    [lower95, lowerind95]=min(lower_vec(i,:));
    [upper95, upperind95]=max(upper_vec(i,:));
    [lowerend, lowerind]=min(est_vec(i,:));
    [upperend, upperind]=max(est_vec(i,:));
    results=[results; lowerend, se_vec(i, lowerind), upperend, se_vec(i, upperind), lower95, upper95 ];
end

if estorconfidence==1 % Set Estimate
    results=results(:,1:4);
elseif estorconfidence==2 % Confidence Region
    results=results(:,5:6);
elseif estorconfidence==3 % both Set Estimate and Confidence Region    
    results=results;
end