% 2sls (Given S1, instrument for lKWW: interaction of educ exper expersq black with S1 and low parental education)

%Generating the S1 indicators
s1_ind=zeros(num_raw_obs,4);

for k=1:num_raw_obs
    %% populating binary s1 indicators
    if raw_x(k,5)==0 && raw_x(k,6)==0 
        s1_ind(k,1)=1;
    elseif raw_x(k,5)==0 && raw_x(k,6)==1 
        s1_ind(k,2)=1;
    elseif raw_x(k,5)==1 && raw_x(k,6)==0 
        s1_ind(k,3)=1;
    else % if raw_x(k,5)==1 && raw_x(k,6)==1 
        s1_ind(k,4)=1;
    end    
end

length_x=7;
length_z=22;

%% excluding data that are missing KWW
exclusion_vec=zeros(1,num_raw_obs);
for k=1:num_raw_obs
    if raw_iq_kww(k)==-1
        exclusion_vec(k)=1;
    else
        num_valid_obs=num_valid_obs+1;
    end
end

x=zeros(num_valid_obs,length_x);
z=zeros(num_valid_obs,length_z);
y=zeros(num_valid_obs,1);
mom_edu=zeros(num_valid_obs,1);
dad_edu=zeros(num_valid_obs,1);

%% Populates x, z, and y

p=0;
for k=1:num_raw_obs
    if exclusion_vec(k)==0
        p=p+1;
        x(p,1:6)=raw_x(k,1:6);
        x(p,7)=log(raw_kww(k)); % lKWW
        
        dad_edu(p)=raw_x(k,16);
        mom_edu(p)=raw_x(k,17);
        
        z(p,1:6)=raw_x(k,1:6);
        z(p,7:9)=raw_x(k,1).*s1_ind(k,2:4);
        z(p,10:12)=raw_x(k,2).*s1_ind(k,2:4);
        z(p,13:15)=raw_x(k,3).*s1_ind(k,2:4);
        z(p,16:18)=raw_x(k,4).*s1_ind(k,2:4);

        y(p)=raw_lwage(k);
    end
end

% Generating the interaction of educ, exper, expersq, black with the low
% parental education

impute_parental_edu_3;


