% 2sls (Given GS, instrument for lKWW: interaction of educ exper expersq black with S1 and low parental education)

%Generating the S1 indicators
s1_ind=zeros(num_raw_obs,4);

for k=1:num_raw_obs
    %% populating binary s1 indicators
    if raw_x(k,5)==0 && raw_x(k,6)==0 
        s1_ind(k,1)=1;
    elseif raw_x(k,5)==0 && raw_x(k,6)==1 
        s1_ind(k,2)=1;
    elseif raw_x(k,5)==1 && raw_x(k,6)==0 
        s1_ind(k,3)=1;
    else % if raw_x(k,5)==1 && raw_x(k,6)==1 
        s1_ind(k,4)=1;
    end    
end

length_x=30;
length_z=45;
num_valid_obs=0;

%% excluding data that are missing KWW
exclusion_vec=zeros(1,num_raw_obs);
for k=1:num_raw_obs
    if raw_iq_kww(k)==-1
        exclusion_vec(k)=1;
    else
        num_valid_obs=num_valid_obs+1;
    end
end

x=zeros(num_valid_obs,length_x);
z=zeros(num_valid_obs,length_z);
y=zeros(num_valid_obs,1);
dad_edu=zeros(num_valid_obs,1);
mom_edu=zeros(num_valid_obs,1);

%% Populates x, z, and y
p=0;
for k=1:num_raw_obs
    if exclusion_vec(k)==0
        p=p+1;
        x(p,1:15)=raw_x(k,1:15);
        dad_edu(p)=raw_x(k,16);
        mom_edu(p)=raw_x(k,17);
        x(p,28:29)=raw_x(k,18:19); % family structure
        x(p,30)=log(raw_kww(k)); % lKWW

        z(p,1:15)=raw_x(k,1:15);
        z(p,28:29)=raw_z(k,18:19); % family structure
        
        z(p,30:32)=raw_x(k,1).*s1_ind(k,2:4);
        z(p,33:35)=raw_x(k,2).*s1_ind(k,2:4);
        z(p,36:38)=raw_x(k,3).*s1_ind(k,2:4);
        z(p,39:41)=raw_x(k,4).*s1_ind(k,2:4);  

        y(p)=raw_lwage(k);
    end
end

%% imputing Parental education and populating x and z
impute_parental_edu_7;
