%% Setting up global variables
global HS_GRAD COLLEGE_GRAD
HS_GRAD=12;
COLLEGE_GRAD=16;

%% Settign num_valid_obs
num_valid_obs=0;

%% Setting length_x
length_x=0;

% Total number of cases is 25

% Regressions using log(IQ) or log(KWW) as proxy 

% (Table 1 in paper)
% Here, length_x is to be set to
% 6 when conditioning on S1
% 29 when conditioning on GS
% 30 when conditioning on GS plus KWW

if  outcome==1 % OLS (given S1)
    populate_case14;
elseif outcome==2 % Proxy log of IQ (given S1)
    raw_iq_kww=raw_iq;
    populate_case23;
elseif outcome==3 % Proxy log of KWW (given S1)
    raw_iq_kww=raw_kww;    
    populate_case23; 
elseif outcome==4 % OLS (given GS)
    populate_case14;
elseif outcome==5 % Proxy log of IQ (given GS)
    raw_iq_kww=raw_iq;    
    populate_case56;
elseif outcome==6 % Proxy log of KWW (given GS)
    raw_iq_kww=raw_kww;       
    populate_case56;
    
% Regressions with Total Education Interacted with Black and predictive proxy using IQ or KWW
% (Table 2 in paper)

elseif outcome==7 % OLS (given S1) | add interaction term (Educ-12)*Black
    populate_case710;
elseif outcome==8 % Proxy log of IQ (given S1) | add interaction term (Educ-12)*Black
    raw_iq_kww=raw_iq;
    populate_case89;
elseif outcome==9 % Proxy log of KWW (given S1) | add interaction term (Educ-12)*Black
    raw_iq_kww=raw_kww;    
    populate_case89; 
elseif outcome==10 % OLS (given GS) | add interaction term (Educ-12)*Black
    populate_case710;
elseif outcome==11 % Proxy log of IQ (given GS)| add interaction (Educ-12)*Black
    raw_iq_kww=raw_iq;    
    populate_case1112;
elseif outcome==12 % Proxy log of KWW (given GS)| add interaction term (Educ-12)*Black
    raw_iq_kww=raw_kww;       
    populate_case1112;
    
% Regressions with Incremental Return to Education and predictive proxy using IQ or KWW
% (Table 4 in paper)

elseif outcome==13 % OLS (given S1)|  replace Educ with binary indicators 
    populate_case1316;
elseif outcome==14 % Proxy log of IQ (given S1) |  replace Educ with binary indicators 
    raw_iq_kww=raw_iq;
    populate_case1415;
elseif outcome==15 % Proxy log of KWW (given S1) |  replace Educ with binary indicators 
    raw_iq_kww=raw_kww;    
    populate_case1415;
elseif outcome==16 % OLS (given GS)|  replace Educ with binary indicators 
    populate_case1316;
elseif outcome==17 % Proxy log of IQ (given GS) |  replace Educ with binary indicators 
    raw_iq_kww=raw_iq;    
    populate_case1718;
elseif outcome==18 % Proxy log of KWW (given GS)  |  replace Educ with binary indicators 
    raw_iq_kww=raw_kww;       
    populate_case1718;    

% Regression with Total Education conditioning on log(KWW)
% Perfect Proxy given S1
elseif outcome==19 % OLS of log(KWW) (given S1)  |  Condition on log(KWW)
    raw_iq_kww=raw_kww;       
    populate_case19;  
    
% Regressions with Total Education conditioning on log(KWW)
% Perfect Proxy given GS
elseif outcome==20 % OLS (given GS)  |  Condition on log(KWW)
    raw_iq_kww=raw_kww;       
    populate_case20;  
    
% Regression of log(KWW) with Total Education conditioning on lwage
% Used to obtain measurement error bounds.
elseif outcome==21 % OLS of log(KWW) (given GS) | Condition on log(Wage)
    raw_iq_kww=raw_kww;       
    populate_case21;  

% Regression with Total Education and (Educ-12)*Black conditioning on log(KWW)
% Perfect Proxy given S1
elseif outcome==22 % OLS (given S1) | add interaction (Educ-12)*Black | Condition on log(KWW)
    raw_iq_kww=raw_kww;       
    populate_case2223;  
    
% Regressions with Total Education and (Educ-12)*Black conditioning on log(KWW)
% Perfect Proxy given GS
elseif outcome==23 % OLS (given GS) | add interaction (Educ-12)*Black | Condition on log(KWW)
    raw_iq_kww=raw_kww;       
    populate_case2223;  
    
% Regression with Total Education conditioning on log(KWW)
% Perfect Proxy given S1
elseif outcome==24 % OLS (given S1) | replace Educ with binary indicators | Condition on log(KWW)
    raw_iq_kww=raw_kww;       
    populate_case2425;  
    
% Regressions with Total Education conditioning on log(KWW)
% Perfect Proxy given GS
elseif outcome==25 % OLS (given GS) | replace Educ with binary indicators | Condition on log(KWW)
    raw_iq_kww=raw_kww;       
    populate_case2425;  
    
end