global input_alpha
%% Calculating estimates

% OLS regressions
if outcome==1 || outcome==4 || outcome==7 || outcome==10 || outcome==13 || outcome==16 || outcome==19 || outcome==20 || outcome==21 || outcome==22 || outcome==23 || outcome==24 || outcome==25 
    
    x_tilde=zeros(num_valid_obs,length_x);
    for xcount=1:length_x
        x_tilde(:,xcount)=x(:,xcount)-mean(x(:,xcount));
    end
    y_tilde=y-mean(y);
    R_y_x_tilde=simple_regression(y_tilde, x_tilde);
    eps_y_x_tilde=  y_tilde-x_tilde*R_y_x_tilde';
    std_y_x_tilde=  get_std_error(x_tilde,eps_y_x_tilde, length_x);
    
else % Identification regions
    x_tilde=zeros(num_valid_obs,length_x);
    for xcount=1:length_x
        x_tilde(:,xcount)=x(:,xcount)-mean(x(:,xcount));
    end
    y_tilde=y-mean(y);
    w_tilde=w-mean(w);
    
    R_y_x_tilde=   simple_regression(y_tilde, x_tilde);
    eps_y_x_tilde=  y_tilde-x_tilde*R_y_x_tilde';
    std_y_x_tilde=  get_std_error(x_tilde,eps_y_x_tilde, length_x);
    
    R_w_x_tilde=simple_regression(w_tilde, x_tilde);
    eps_w_x_tilde=w_tilde-x_tilde*R_w_x_tilde';
    std_w_x_tilde=  get_std_error(x_tilde,eps_w_x_tilde, length_x);
    
    %% Covariance matrix
    newvar=x_tilde.*repmat(eps_y_x_tilde, 1, length_x);
    newvar=[newvar x_tilde.*repmat(eps_w_x_tilde, 1, length_x)];
    Xi=cov(newvar, 1);

    Q=[x_tilde'*x_tilde/num_valid_obs zeros(length_x,length_x); zeros(length_x,length_x) x_tilde'*x_tilde/num_valid_obs];  
    Gamma=inv(Q)*Xi*inv(Q');
    
    %% Computing bound estimates and confidence regions
    % Specify the function and gradient
    betaestfunc=@(d) R_y_x_tilde-d*R_w_x_tilde;
    Gfunc=@(d) [eye(length_x) -d*eye(length_x)];

    % Obtain bound estimate and confidence regions
    tempest=setBoundsd(betaestfunc, Gfunc, 0, Gamma, num_valid_obs, length_x, 3);
    tempestmag=setBoundsd(betaestfunc, Gfunc, -1, Gamma, num_valid_obs, length_x, 3);
    
end

%% Printing Results
    fprintf(1,'\nNumber of Observations: %d\n',num_valid_obs);

for betacount=1:length_x
    generate_xlabels;
    if outcome==1 || outcome==4 || outcome==7 || outcome==10 || outcome==13  || outcome==16 || outcome==19 || outcome==20 || outcome==21 || outcome==22 || outcome==23 || outcome==24 || outcome==25
        stderror=std_y_x_tilde(betacount);
        
        c_alpha=norminv(1-(input_alpha/2),0,1);
        lower_ci=R_y_x_tilde(betacount)-c_alpha*stderror;
        upper_ci=R_y_x_tilde(betacount)+c_alpha*stderror;
        
        fprintf(1,'%s: R_y_x: %d | Std error: %d | CI: [%d %d]\n', xlabels, R_y_x_tilde(betacount), stderror, lower_ci, upper_ci );
        
         
    else % outcome==2, 3, 5, 6, 8, 9, 11, 12, 14, 15, 17, 18
         stderror=std_y_x_tilde(betacount);
        
         c_alpha=norminv(1-(input_alpha/2),0,1);
         lower_ci=R_y_x_tilde(betacount)-c_alpha*stderror;
         upper_ci=R_y_x_tilde(betacount)+c_alpha*stderror;
        
         fprintf(1,'%s: R_y_x: %d | Std error: %d | CI: [%d %d] \n',xlabels, R_y_x_tilde(betacount), stderror, lower_ci, upper_ci);
        
        tstatvalue=R_w_x_tilde(betacount)/std_w_x_tilde(betacount);
        pvalue=2*(1-normcdf(abs(tstatvalue))); %% two sided p-value
        fprintf(1,'R_w_x: %d | std error: %d | p-value: %d\n',R_w_x_tilde(betacount) ,std_w_x_tilde(betacount),pvalue);
        
        %% Reporting set estimates and confidence regions
      
        fprintf(1,'Identified region sign and mag: [%d %d]\n',tempest(betacount,[1 3]));
        fprintf(1,'CI:[%d %d]\n', tempest(betacount,[5 6]));
        fprintf(1,'Identified region mag: [%d %d]\n',tempestmag(betacount,[1 3]));
        fprintf(1,'CI:[%d %d]\n\n', tempestmag(betacount,[5 6]));

   
    end
    
        %% This is used to draw Graphs
    
    if  outcome==15 && betacount<=17
        edu_ind_estimates(1, betacount)= R_y_x_tilde(betacount);
        edu_lower_bound(1, betacount)=tempest(betacount, 1);
        edu_upper_bound(1, betacount)=tempest(betacount, 3);
        mag_edu_lower_bound(1, betacount)=tempestmag(betacount, 1);
        mag_edu_upper_bound(1, betacount)=tempestmag(betacount, 3);
        edu_lower_cis(1, betacount)=tempest(betacount, 5);
        edu_upper_cis(1, betacount)=tempest(betacount, 6);
        mag_edu_lower_cis(1, betacount)=tempestmag(betacount, 5);
        mag_edu_upper_cis(1, betacount)=tempestmag(betacount, 6); 
        
    elseif outcome==18 && betacount<=17
        edu_ind_estimates(2, betacount)= R_y_x_tilde(betacount);
        edu_lower_bound(2, betacount)=tempest(betacount, 1);
        edu_upper_bound(2, betacount)=tempest(betacount, 3);
        mag_edu_lower_bound(2, betacount)=tempestmag(betacount, 1);
        mag_edu_upper_bound(2, betacount)=tempestmag(betacount, 3);
        edu_lower_cis(2, betacount)=tempest(betacount, 5);
        edu_upper_cis(2, betacount)=tempest(betacount, 6);
        mag_edu_lower_cis(2, betacount)=tempestmag(betacount, 5);
        mag_edu_upper_cis(2, betacount)=tempestmag(betacount, 6); 
           
    end         
   
end